/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.296 Revision 1.380
1# Copyright 1999-2007 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.296 2008/02/13 20:50:06 wolf31o2 Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.380 2012/01/31 06:55:37 ulm Exp $
4 4
5# @ECLASS: eutils.eclass 5# @ECLASS: eutils.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# base-system@gentoo.org 7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds 8# @BLURB: many extra (but common) functions that are used in ebuilds
13# home rather than having multiple ebuilds implementing the same thing. 13# home rather than having multiple ebuilds implementing the same thing.
14# 14#
15# Due to the nature of this eclass, some functions may have maintainers 15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass! 16# different from the overall eclass!
17 17
18if [[ ${___ECLASS_ONCE_EUTILS} != "recur -_+^+_- spank" ]] ; then
19___ECLASS_ONCE_EUTILS="recur -_+^+_- spank"
20
18inherit multilib portability 21inherit multilib portability user
19 22
20DESCRIPTION="Based on the ${ECLASS} eclass" 23DESCRIPTION="Based on the ${ECLASS} eclass"
24
25if has "${EAPI:-0}" 0 1 2; then
21 26
22# @FUNCTION: epause 27# @FUNCTION: epause
23# @USAGE: [seconds] 28# @USAGE: [seconds]
24# @DESCRIPTION: 29# @DESCRIPTION:
25# Sleep for the specified number of seconds (default of 5 seconds). Useful when 30# Sleep for the specified number of seconds (default of 5 seconds). Useful when
26# printing a message the user should probably be reading and often used in 31# printing a message the user should probably be reading and often used in
27# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set, 32# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
28# don't wait at all. 33# don't wait at all. Defined in EAPIs 0 1 and 2.
29epause() { 34epause() {
30 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5} 35 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
31} 36}
32 37
33# @FUNCTION: ebeep 38# @FUNCTION: ebeep
34# @USAGE: [number of beeps] 39# @USAGE: [number of beeps]
35# @DESCRIPTION: 40# @DESCRIPTION:
36# Issue the specified number of beeps (default of 5 beeps). Useful when 41# Issue the specified number of beeps (default of 5 beeps). Useful when
37# printing a message the user should probably be reading and often used in 42# printing a message the user should probably be reading and often used in
38# conjunction with the epause function. If the EBEEP_IGNORE env var is set, 43# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
39# don't beep at all. 44# don't beep at all. Defined in EAPIs 0 1 and 2.
40ebeep() { 45ebeep() {
41 local n 46 local n
42 if [[ -z ${EBEEP_IGNORE} ]] ; then 47 if [[ -z ${EBEEP_IGNORE} ]] ; then
43 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 48 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
44 echo -ne "\a" 49 echo -ne "\a"
47 sleep 1 52 sleep 1
48 done 53 done
49 fi 54 fi
50} 55}
51 56
52# Default directory where patches are located 57else
58
59ebeep() {
60 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
61}
62
63epause() {
64 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
65}
66
67fi
68
69# @FUNCTION: eqawarn
70# @USAGE: [message]
71# @DESCRIPTION:
72# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
73# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
74# profile.
75if ! declare -F eqawarn >/dev/null ; then
76 eqawarn() {
77 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
78 :
79 }
80fi
81
82# @FUNCTION: ecvs_clean
83# @USAGE: [list of dirs]
84# @DESCRIPTION:
85# Remove CVS directories recursiveley. Useful when a source tarball contains
86# internal CVS directories. Defaults to $PWD.
87ecvs_clean() {
88 [[ -z $* ]] && set -- .
89 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
90 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
91}
92
93# @FUNCTION: esvn_clean
94# @USAGE: [list of dirs]
95# @DESCRIPTION:
96# Remove .svn directories recursiveley. Useful when a source tarball contains
97# internal Subversion directories. Defaults to $PWD.
98esvn_clean() {
99 [[ -z $* ]] && set -- .
100 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
101}
102
103# @FUNCTION: estack_push
104# @USAGE: <stack> [items to push]
105# @DESCRIPTION:
106# Push any number of items onto the specified stack. Pick a name that
107# is a valid variable (i.e. stick to alphanumerics), and push as many
108# items as you like onto the stack at once.
109#
110# The following code snippet will echo 5, then 4, then 3, then ...
111# @CODE
112# estack_push mystack 1 2 3 4 5
113# while estack_pop mystack i ; do
114# echo "${i}"
115# done
116# @CODE
117estack_push() {
118 [[ $# -eq 0 ]] && die "estack_push: incorrect # of arguments"
119 local stack_name="__ESTACK_$1__" ; shift
120 eval ${stack_name}+=\( \"\$@\" \)
121}
122
123# @FUNCTION: estack_pop
124# @USAGE: <stack> [variable]
125# @DESCRIPTION:
126# Pop a single item off the specified stack. If a variable is specified,
127# the popped item is stored there. If no more items are available, return
128# 1, else return 0. See estack_push for more info.
129estack_pop() {
130 [[ $# -eq 0 || $# -gt 2 ]] && die "estack_pop: incorrect # of arguments"
131
132 # We use the fugly __estack_xxx var names to avoid collision with
133 # passing back the return value. If we used "local i" and the
134 # caller ran `estack_pop ... i`, we'd end up setting the local
135 # copy of "i" rather than the caller's copy. The __estack_xxx
136 # garbage is preferable to using $1/$2 everywhere as that is a
137 # bit harder to read.
138 local __estack_name="__ESTACK_$1__" ; shift
139 local __estack_retvar=$1 ; shift
140 eval local __estack_i=\${#${__estack_name}\[@\]}
141 # Don't warn -- let the caller interpret this as a failure
142 # or as normal behavior (akin to `shift`)
143 [[ $(( --__estack_i )) -eq -1 ]] && return 1
144
145 if [[ -n ${__estack_retvar} ]] ; then
146 eval ${__estack_retvar}=\"\${${__estack_name}\[${__estack_i}\]}\"
147 fi
148 eval unset ${__estack_name}\[${__estack_i}\]
149}
150
151# @FUNCTION: eshopts_push
152# @USAGE: [options to `set` or `shopt`]
153# @DESCRIPTION:
154# Often times code will want to enable a shell option to change code behavior.
155# Since changing shell options can easily break other pieces of code (which
156# assume the default state), eshopts_push is used to (1) push the current shell
157# options onto a stack and (2) pass the specified arguments to set.
158#
159# If the first argument is '-s' or '-u', we assume you want to call `shopt`
160# rather than `set` as there are some options only available via that.
161#
162# A common example is to disable shell globbing so that special meaning/care
163# may be used with variables/arguments to custom functions. That would be:
164# @CODE
165# eshopts_push -s noglob
166# for x in ${foo} ; do
167# if ...some check... ; then
168# eshopts_pop
169# return 0
170# fi
171# done
172# eshopts_pop
173# @CODE
174eshopts_push() {
175 if [[ $1 == -[su] ]] ; then
176 estack_push eshopts "$(shopt -p)"
177 [[ $# -eq 0 ]] && return 0
178 shopt "$@" || die "${FUNCNAME}: bad options to shopt: $*"
179 else
180 estack_push eshopts $-
181 [[ $# -eq 0 ]] && return 0
182 set "$@" || die "${FUNCNAME}: bad options to set: $*"
183 fi
184}
185
186# @FUNCTION: eshopts_pop
187# @USAGE:
188# @DESCRIPTION:
189# Restore the shell options to the state saved with the corresponding
190# eshopts_push call. See that function for more details.
191eshopts_pop() {
192 local s
193 estack_pop eshopts s || die "${FUNCNAME}: unbalanced push"
194 if [[ ${s} == "shopt -"* ]] ; then
195 eval "${s}" || die "${FUNCNAME}: sanity: invalid shopt options: ${s}"
196 else
197 set +$- || die "${FUNCNAME}: sanity: invalid shell settings: $-"
198 set -${s} || die "${FUNCNAME}: sanity: unable to restore saved shell settings: ${s}"
199 fi
200}
201
202# @FUNCTION: eumask_push
203# @USAGE: <new umask>
204# @DESCRIPTION:
205# Set the umask to the new value specified while saving the previous
206# value onto a stack. Useful for temporarily changing the umask.
207eumask_push() {
208 estack_push eumask "$(umask)"
209 umask "$@" || die "${FUNCNAME}: bad options to umask: $*"
210}
211
212# @FUNCTION: eumask_pop
213# @USAGE:
214# @DESCRIPTION:
215# Restore the previous umask state.
216eumask_pop() {
217 local s
218 estack_pop eumask s || die "${FUNCNAME}: unbalanced push"
219 umask ${s} || die "${FUNCNAME}: sanity: could not restore umask: ${s}"
220}
221
222# @VARIABLE: EPATCH_SOURCE
223# @DESCRIPTION:
224# Default directory to search for patches.
53EPATCH_SOURCE="${WORKDIR}/patch" 225EPATCH_SOURCE="${WORKDIR}/patch"
54# Default extension for patches 226# @VARIABLE: EPATCH_SUFFIX
227# @DESCRIPTION:
228# Default extension for patches (do not prefix the period yourself).
55EPATCH_SUFFIX="patch.bz2" 229EPATCH_SUFFIX="patch.bz2"
230# @VARIABLE: EPATCH_OPTS
231# @DESCRIPTION:
56# Default options for patch 232# Default options for patch:
233# @CODE
57# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 234# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
58# Set --no-backup-if-mismatch so we don't leave '.orig' files behind. 235# --no-backup-if-mismatch - do not leave .orig files behind
59# Set -E to automatically remove empty files. 236# -E - automatically remove empty files
237# @CODE
60EPATCH_OPTS="-g0 -E --no-backup-if-mismatch" 238EPATCH_OPTS="-g0 -E --no-backup-if-mismatch"
239# @VARIABLE: EPATCH_EXCLUDE
240# @DESCRIPTION:
61# List of patches not to apply. Not this is only file names, 241# List of patches not to apply. Note this is only file names,
62# and not the full path .. 242# and not the full path. Globs accepted.
63EPATCH_EXCLUDE="" 243EPATCH_EXCLUDE=""
244# @VARIABLE: EPATCH_SINGLE_MSG
245# @DESCRIPTION:
64# Change the printed message for a single patch. 246# Change the printed message for a single patch.
65EPATCH_SINGLE_MSG="" 247EPATCH_SINGLE_MSG=""
248# @VARIABLE: EPATCH_MULTI_MSG
249# @DESCRIPTION:
66# Change the printed message for multiple patches. 250# Change the printed message for multiple patches.
67EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..." 251EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
68# Force applying bulk patches even if not following the style: 252# @VARIABLE: EPATCH_FORCE
69# 253# @DESCRIPTION:
70# ??_${ARCH}_foo.${EPATCH_SUFFIX} 254# Only require patches to match EPATCH_SUFFIX rather than the extended
71# 255# arch naming style.
72EPATCH_FORCE="no" 256EPATCH_FORCE="no"
73 257
74# This function is for bulk patching, or in theory for just one 258# @FUNCTION: epatch
75# or two patches. 259# @USAGE: [patches] [dirs of patches]
260# @DESCRIPTION:
261# epatch is designed to greatly simplify the application of patches. It can
262# process patch files directly, or directories of patches. The patches may be
263# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
264# the -p option as epatch will automatically attempt -p0 to -p5 until things
265# apply successfully.
76# 266#
77# It should work with .bz2, .gz, .zip and plain text patches. 267# If you do not specify any options, then epatch will default to the directory
78# Currently all patches should be the same format. 268# specified by EPATCH_SOURCE.
79# 269#
80# You do not have to specify '-p' option to patch, as it will 270# When processing directories, epatch will apply all patches that match:
81# try with -p0 to -p5 until it succeed, or fail at -p5. 271# @CODE
82# 272# if ${EPATCH_FORCE} != "yes"
83# Above EPATCH_* variables can be used to control various defaults,
84# bug they should be left as is to ensure an ebuild can rely on
85# them for.
86#
87# Patches are applied in current directory.
88#
89# Bulk Patches should preferibly have the form of:
90#
91# ??_${ARCH}_foo.${EPATCH_SUFFIX} 273# ??_${ARCH}_foo.${EPATCH_SUFFIX}
274# else
275# *.${EPATCH_SUFFIX}
276# @CODE
277# The leading ?? are typically numbers used to force consistent patch ordering.
278# The arch field is used to apply patches only for the host architecture with
279# the special value of "all" means apply for everyone. Note that using values
280# other than "all" is highly discouraged -- you should apply patches all the
281# time and let architecture details be detected at configure/compile time.
92# 282#
93# For example: 283# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
284# for patches to apply.
94# 285#
95# 01_all_misc-fix.patch.bz2 286# Refer to the other EPATCH_xxx variables for more customization of behavior.
96# 02_sparc_another-fix.patch.bz2
97#
98# This ensures that there are a set order, and you can have ARCH
99# specific patches.
100#
101# If you however give an argument to epatch(), it will treat it as a
102# single patch that need to be applied if its a file. If on the other
103# hand its a directory, it will set EPATCH_SOURCE to this.
104#
105# <azarah@gentoo.org> (10 Nov 2002)
106#
107epatch() { 287epatch() {
108 _epatch_draw_line() { 288 _epatch_draw_line() {
289 # create a line of same length as input string
109 [[ -z $1 ]] && set "$(printf "%65s" '')" 290 [[ -z $1 ]] && set "$(printf "%65s" '')"
110 echo "${1//?/=}" 291 echo "${1//?/=}"
111 } 292 }
112 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
113 local PIPE_CMD=""
114 local STDERR_TARGET="${T}/$$.out"
115 local PATCH_TARGET="${T}/$$.patch"
116 local PATCH_SUFFIX=""
117 local SINGLE_PATCH="no"
118 local x=""
119 293
120 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402 294 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
121 295
122 if [ "$#" -gt 1 ] 296 # Let the rest of the code process one user arg at a time --
123 then 297 # each arg may expand into multiple patches, and each arg may
298 # need to start off with the default global EPATCH_xxx values
299 if [[ $# -gt 1 ]] ; then
124 local m="" 300 local m
125 for m in "$@" ; do 301 for m in "$@" ; do
126 epatch "${m}" 302 epatch "${m}"
127 done 303 done
128 return 0 304 return 0
129 fi 305 fi
130 306
131 if [ -n "$1" -a -f "$1" ] 307 local SINGLE_PATCH="no"
132 then 308 # no args means process ${EPATCH_SOURCE}
309 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
310
311 if [[ -f $1 ]] ; then
133 SINGLE_PATCH="yes" 312 SINGLE_PATCH="yes"
134 313 set -- "$1"
135 local EPATCH_SOURCE="$1" 314 # Use the suffix from the single patch (localize it); the code
315 # below will find the suffix for us
136 local EPATCH_SUFFIX="${1##*\.}" 316 local EPATCH_SUFFIX=$1
137 317
138 elif [ -n "$1" -a -d "$1" ] 318 elif [[ -d $1 ]] ; then
139 then 319 # Some people like to make dirs of patches w/out suffixes (vim)
140 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 320 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
141 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 321
322 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
323 # Re-use EPATCH_SOURCE as a search dir
324 epatch "${EPATCH_SOURCE}/$1"
325 return $?
326
327 else
328 # sanity check ... if it isn't a dir or file, wtf man ?
329 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
330 echo
331 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
332 eerror
333 eerror " ${EPATCH_SOURCE}"
334 eerror " ( ${EPATCH_SOURCE##*/} )"
335 echo
336 die "Cannot find \$EPATCH_SOURCE!"
337 fi
338
339 local PIPE_CMD
340 case ${EPATCH_SUFFIX##*\.} in
341 xz) PIPE_CMD="xz -dc" ;;
342 lzma) PIPE_CMD="lzma -dc" ;;
343 bz2) PIPE_CMD="bzip2 -dc" ;;
344 gz|Z|z) PIPE_CMD="gzip -dc" ;;
345 ZIP|zip) PIPE_CMD="unzip -p" ;;
346 *) ;;
347 esac
348
349 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
350
351 local x
352 for x in "$@" ; do
353 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
354 # didn't match anything, ignore continue on
355 [[ ! -f ${x} ]] && continue
356
357 local patchname=${x##*/}
358
359 # Apply single patches, or forced sets of patches, or
360 # patches with ARCH dependant names.
361 # ???_arch_foo.patch
362 # Else, skip this input altogether
363 local a=${patchname#*_} # strip the ???_
364 a=${a%%_*} # strip the _foo.patch
365 if ! [[ ${SINGLE_PATCH} == "yes" || \
366 ${EPATCH_FORCE} == "yes" || \
367 ${a} == all || \
368 ${a} == ${ARCH} ]]
142 then 369 then
143 local EPATCH_SOURCE="$1/*" 370 continue
371 fi
372
373 # Let people filter things dynamically
374 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
375 # let people use globs in the exclude
376 eshopts_push -o noglob
377
378 local ex
379 for ex in ${EPATCH_EXCLUDE} ; do
380 if [[ ${patchname} == ${ex} ]] ; then
381 eshopts_pop
382 continue 2
383 fi
384 done
385
386 eshopts_pop
387 fi
388
389 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
390 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
391 einfo "${EPATCH_SINGLE_MSG}"
392 else
393 einfo "Applying ${patchname} ..."
394 fi
144 else 395 else
145 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 396 einfo " ${patchname} ..."
146 fi 397 fi
147 else 398
148 if [[ ! -d ${EPATCH_SOURCE} ]] || [[ -n $1 ]] ; then 399 # most of the time, there will only be one run per unique name,
149 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 400 # but if there are more, make sure we get unique log filenames
150 then 401 local STDERR_TARGET="${T}/${patchname}.out"
151 EPATCH_SOURCE="$1" 402 if [[ -e ${STDERR_TARGET} ]] ; then
403 STDERR_TARGET="${T}/${patchname}-$$.out"
404 fi
405
406 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
407
408 # Decompress the patch if need be
409 local count=0
410 local PATCH_TARGET
411 if [[ -n ${PIPE_CMD} ]] ; then
412 PATCH_TARGET="${T}/$$.patch"
413 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
414
415 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
416 echo
417 eerror "Could not extract patch!"
418 #die "Could not extract patch!"
419 count=5
420 break
152 fi 421 fi
422 else
423 PATCH_TARGET=${x}
424 fi
153 425
426 # Check for absolute paths in patches. If sandbox is disabled,
427 # people could (accidently) patch files in the root filesystem.
428 # Or trigger other unpleasantries #237667. So disallow -p0 on
429 # such patches.
430 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
431 if [[ -n ${abs_paths} ]] ; then
432 count=1
433 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
434 fi
435 # Similar reason, but with relative paths.
436 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
437 if [[ -n ${rel_paths} ]] ; then
438 eqawarn "QA Notice: Your patch uses relative paths '../'."
439 eqawarn " In the future this will cause a failure."
440 eqawarn "${rel_paths}"
441 fi
442
443 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
444 while [[ ${count} -lt 5 ]] ; do
445 # Generate some useful debug info ...
446 (
447 _epatch_draw_line "***** ${patchname} *****"
154 echo 448 echo
155 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 449 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'"
450 echo
451 _epatch_draw_line "***** ${patchname} *****"
452 patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}" 2>&1
453 ret=$?
454 echo
455 echo "patch program exited with status ${ret}"
456 exit ${ret}
457 ) >> "${STDERR_TARGET}"
458
459 if [ $? -eq 0 ] ; then
460 (
461 _epatch_draw_line "***** ${patchname} *****"
462 echo
463 echo "ACTUALLY APPLYING ${patchname} ..."
464 echo
465 _epatch_draw_line "***** ${patchname} *****"
466 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1
467 ret=$?
468 echo
469 echo "patch program exited with status ${ret}"
470 exit ${ret}
471 ) >> "${STDERR_TARGET}"
472
473 if [ $? -ne 0 ] ; then
474 echo
475 eerror "A dry-run of patch command succeeded, but actually"
476 eerror "applying the patch failed!"
477 #die "Real world sux compared to the dreamworld!"
478 count=5
479 fi
480 break
481 fi
482
483 : $(( count++ ))
484 done
485
486 # if we had to decompress the patch, delete the temp one
487 if [[ -n ${PIPE_CMD} ]] ; then
488 rm -f "${PATCH_TARGET}"
489 fi
490
491 if [[ ${count} -ge 5 ]] ; then
492 echo
493 eerror "Failed Patch: ${patchname} !"
494 eerror " ( ${PATCH_TARGET} )"
156 eerror 495 eerror
157 eerror " ${EPATCH_SOURCE}" 496 eerror "Include in your bugreport the contents of:"
158 eerror " ( ${EPATCH_SOURCE##*/} )" 497 eerror
498 eerror " ${STDERR_TARGET}"
159 echo 499 echo
160 die "Cannot find \$EPATCH_SOURCE!"
161 fi
162
163 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
164 fi
165
166 case ${EPATCH_SUFFIX##*\.} in
167 bz2)
168 PIPE_CMD="bzip2 -dc"
169 PATCH_SUFFIX="bz2"
170 ;;
171 gz|Z|z)
172 PIPE_CMD="gzip -dc"
173 PATCH_SUFFIX="gz"
174 ;;
175 ZIP|zip)
176 PIPE_CMD="unzip -p"
177 PATCH_SUFFIX="zip"
178 ;;
179 *)
180 PIPE_CMD="cat"
181 PATCH_SUFFIX="patch"
182 ;;
183 esac
184
185 if [ "${SINGLE_PATCH}" = "no" ]
186 then
187 einfo "${EPATCH_MULTI_MSG}"
188 fi
189 for x in ${EPATCH_SOURCE}
190 do
191 # New ARCH dependant patch naming scheme ...
192 #
193 # ???_arch_foo.patch
194 #
195 if [ -f ${x} ] && \
196 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "${x/_${ARCH}_}" != "${x}" ] || \
197 [ "${EPATCH_FORCE}" = "yes" ])
198 then
199 local count=0
200 local popts="${EPATCH_OPTS}"
201 local patchname=${x##*/}
202
203 if [ -n "${EPATCH_EXCLUDE}" ]
204 then
205 if [ "${EPATCH_EXCLUDE/${patchname}}" != "${EPATCH_EXCLUDE}" ]
206 then
207 continue
208 fi
209 fi
210
211 if [ "${SINGLE_PATCH}" = "yes" ]
212 then
213 if [ -n "${EPATCH_SINGLE_MSG}" ]
214 then
215 einfo "${EPATCH_SINGLE_MSG}"
216 else
217 einfo "Applying ${patchname} ..."
218 fi
219 else
220 einfo " ${patchname} ..."
221 fi
222
223 echo "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
224 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
225
226 # Allow for prefix to differ ... im lazy, so shoot me :/
227 while [ "${count}" -lt 5 ]
228 do
229 # Generate some useful debug info ...
230 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
231 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
232
233 if [ "${PATCH_SUFFIX}" != "patch" ]
234 then
235 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
236 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
237 else
238 PATCH_TARGET="${x}"
239 fi
240
241 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
242 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
243
244 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
245 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
246
247 if [ "${PATCH_SUFFIX}" != "patch" ]
248 then
249 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
250 then
251 echo
252 eerror "Could not extract patch!"
253 #die "Could not extract patch!"
254 count=5
255 break
256 fi
257 fi
258
259 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
260 then
261 _epatch_draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
262 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
263 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
264 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
265 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
266
267 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
268 _epatch_assert
269
270 if [ "$?" -ne 0 ]
271 then
272 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
273 echo
274 eerror "A dry-run of patch command succeeded, but actually"
275 eerror "applying the patch failed!"
276 #die "Real world sux compared to the dreamworld!"
277 count=5
278 fi
279
280 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
281
282 break
283 fi
284
285 count=$((count + 1))
286 done
287
288 if [ "${PATCH_SUFFIX}" != "patch" ]
289 then
290 rm -f ${PATCH_TARGET}
291 fi
292
293 if [ "${count}" -eq 5 ]
294 then
295 echo
296 eerror "Failed Patch: ${patchname} !"
297 eerror " ( ${PATCH_TARGET} )"
298 eerror
299 eerror "Include in your bugreport the contents of:"
300 eerror
301 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}"
302 echo
303 die "Failed Patch: ${patchname}!" 500 die "Failed Patch: ${patchname}!"
304 fi 501 fi
305 502
306 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 503 # if everything worked, delete the patch log
307 504 rm -f "${STDERR_TARGET}"
308 eend 0 505 eend 0
309 fi
310 done 506 done
311 if [ "${SINGLE_PATCH}" = "no" ] 507
312 then 508 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
313 einfo "Done with patching" 509 : # everything worked
510}
511
512# @FUNCTION: epatch_user
513# @USAGE:
514# @DESCRIPTION:
515# Applies user-provided patches to the source tree. The patches are
516# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>/, where the first
517# of these three directories to exist will be the one to use, ignoring
518# any more general directories which might exist as well.
519#
520# User patches are intended for quick testing of patches without ebuild
521# modifications, as well as for permanent customizations a user might
522# desire. Obviously, there can be no official support for arbitrarily
523# patched ebuilds. So whenever a build log in a bug report mentions that
524# user patches were applied, the user should be asked to reproduce the
525# problem without these.
526#
527# Not all ebuilds do call this function, so placing patches in the
528# stated directory might or might not work, depending on the package and
529# the eclasses it inherits and uses. It is safe to call the function
530# repeatedly, so it is always possible to add a call at the ebuild
531# level. The first call is the time when the patches will be
532# applied.
533#
534# Ideally, this function should be called after gentoo-specific patches
535# have been applied, so that their code can be modified as well, but
536# before calls to e.g. eautoreconf, as the user patches might affect
537# autotool input files as well.
538epatch_user() {
539 [[ $# -ne 0 ]] && die "epatch_user takes no options"
540
541 # Allow multiple calls to this function; ignore all but the first
542 local applied="${T}/epatch_user.applied"
543 [[ -e ${applied} ]] && return 2
544
545 # don't clobber any EPATCH vars that the parent might want
546 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
547 for check in ${CATEGORY}/{${P}-${PR},${P},${PN}}; do
548 EPATCH_SOURCE=${base}/${CTARGET}/${check}
549 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
550 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
551 if [[ -d ${EPATCH_SOURCE} ]] ; then
552 EPATCH_SOURCE=${EPATCH_SOURCE} \
553 EPATCH_SUFFIX="patch" \
554 EPATCH_FORCE="yes" \
555 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
556 epatch
557 echo "${EPATCH_SOURCE}" > "${applied}"
558 return 0
314 fi 559 fi
560 done
561 echo "none" > "${applied}"
562 return 1
315} 563}
316 564
317# @FUNCTION: emktemp 565# @FUNCTION: emktemp
318# @USAGE: [temp dir] 566# @USAGE: [temp dir]
319# @DESCRIPTION: 567# @DESCRIPTION:
347 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX 595 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
348 fi 596 fi
349 fi 597 fi
350} 598}
351 599
352# @FUNCTION: egetent
353# @USAGE: <database> <key>
354# @MAINTAINER:
355# base-system@gentoo.org (Linux)
356# Joe Jezak <josejx@gmail.com> (OS X)
357# usata@gentoo.org (OS X)
358# Aaron Walker <ka0ttic@gentoo.org> (FreeBSD)
359# @DESCRIPTION:
360# Small wrapper for getent (Linux), nidump (Mac OS X),
361# and pw (FreeBSD) used in enewuser()/enewgroup()
362egetent() {
363 case ${CHOST} in
364 *-darwin*)
365 case "$2" in
366 *[!0-9]*) # Non numeric
367 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
368 ;;
369 *) # Numeric
370 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
371 ;;
372 esac
373 ;;
374 *-freebsd*|*-dragonfly*)
375 local opts action="user"
376 [[ $1 == "passwd" ]] || action="group"
377
378 # lookup by uid/gid
379 if [[ $2 == [[:digit:]]* ]] ; then
380 [[ ${action} == "user" ]] && opts="-u" || opts="-g"
381 fi
382
383 pw show ${action} ${opts} "$2" -q
384 ;;
385 *-netbsd*|*-openbsd*)
386 grep "$2:\*:" /etc/$1
387 ;;
388 *)
389 type -p nscd >& /dev/null && nscd -i "$1"
390 getent "$1" "$2"
391 ;;
392 esac
393}
394
395# @FUNCTION: enewuser
396# @USAGE: <user> [uid] [shell] [homedir] [groups] [params]
397# @DESCRIPTION:
398# Same as enewgroup, you are not required to understand how to properly add
399# a user to the system. The only required parameter is the username.
400# Default uid is (pass -1 for this) next available, default shell is
401# /bin/false, default homedir is /dev/null, there are no default groups,
402# and default params sets the comment as 'added by portage for ${PN}'.
403enewuser() {
404 case ${EBUILD_PHASE} in
405 unpack|compile|test|install)
406 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
407 eerror "Package fails at QA and at life. Please file a bug."
408 die "Bad package! enewuser is only for use in pkg_* functions!"
409 esac
410
411 # get the username
412 local euser=$1; shift
413 if [[ -z ${euser} ]] ; then
414 eerror "No username specified !"
415 die "Cannot call enewuser without a username"
416 fi
417
418 # lets see if the username already exists
419 if [[ -n $(egetent passwd "${euser}") ]] ; then
420 return 0
421 fi
422 einfo "Adding user '${euser}' to your system ..."
423
424 # options to pass to useradd
425 local opts=
426
427 # handle uid
428 local euid=$1; shift
429 if [[ -n ${euid} && ${euid} != -1 ]] ; then
430 if [[ ${euid} -gt 0 ]] ; then
431 if [[ -n $(egetent passwd ${euid}) ]] ; then
432 euid="next"
433 fi
434 else
435 eerror "Userid given but is not greater than 0 !"
436 die "${euid} is not a valid UID"
437 fi
438 else
439 euid="next"
440 fi
441 if [[ ${euid} == "next" ]] ; then
442 for ((euid = 101; euid <= 999; euid++)); do
443 [[ -z $(egetent passwd ${euid}) ]] && break
444 done
445 fi
446 opts="${opts} -u ${euid}"
447 einfo " - Userid: ${euid}"
448
449 # handle shell
450 local eshell=$1; shift
451 if [[ ! -z ${eshell} ]] && [[ ${eshell} != "-1" ]] ; then
452 if [[ ! -e ${ROOT}${eshell} ]] ; then
453 eerror "A shell was specified but it does not exist !"
454 die "${eshell} does not exist in ${ROOT}"
455 fi
456 if [[ ${eshell} == */false || ${eshell} == */nologin ]] ; then
457 eerror "Do not specify ${eshell} yourself, use -1"
458 die "Pass '-1' as the shell parameter"
459 fi
460 else
461 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
462 [[ -x ${ROOT}${shell} ]] && break
463 done
464
465 if [[ ${shell} == "/dev/null" ]] ; then
466 eerror "Unable to identify the shell to use, proceeding with userland default."
467 case ${USERLAND} in
468 GNU) shell="/bin/false" ;;
469 BSD) shell="/sbin/nologin" ;;
470 Darwin) shell="/usr/sbin/nologin" ;;
471 *) die "Unable to identify the default shell for userland ${USERLAND}"
472 esac
473 fi
474
475 eshell=${shell}
476 fi
477 einfo " - Shell: ${eshell}"
478 opts="${opts} -s ${eshell}"
479
480 # handle homedir
481 local ehome=$1; shift
482 if [[ -z ${ehome} ]] || [[ ${ehome} == "-1" ]] ; then
483 ehome="/dev/null"
484 fi
485 einfo " - Home: ${ehome}"
486 opts="${opts} -d ${ehome}"
487
488 # handle groups
489 local egroups=$1; shift
490 if [[ ! -z ${egroups} ]] ; then
491 local oldifs=${IFS}
492 local defgroup="" exgroups=""
493
494 export IFS=","
495 for g in ${egroups} ; do
496 export IFS=${oldifs}
497 if [[ -z $(egetent group "${g}") ]] ; then
498 eerror "You must add group ${g} to the system first"
499 die "${g} is not a valid GID"
500 fi
501 if [[ -z ${defgroup} ]] ; then
502 defgroup=${g}
503 else
504 exgroups="${exgroups},${g}"
505 fi
506 export IFS=","
507 done
508 export IFS=${oldifs}
509
510 opts="${opts} -g ${defgroup}"
511 if [[ ! -z ${exgroups} ]] ; then
512 opts="${opts} -G ${exgroups:1}"
513 fi
514 else
515 egroups="(none)"
516 fi
517 einfo " - Groups: ${egroups}"
518
519 # handle extra and add the user
520 local oldsandbox=${SANDBOX_ON}
521 export SANDBOX_ON="0"
522 case ${CHOST} in
523 *-darwin*)
524 ### Make the user
525 if [[ -z $@ ]] ; then
526 dscl . create /users/${euser} uid ${euid}
527 dscl . create /users/${euser} shell ${eshell}
528 dscl . create /users/${euser} home ${ehome}
529 dscl . create /users/${euser} realname "added by portage for ${PN}"
530 ### Add the user to the groups specified
531 local oldifs=${IFS}
532 export IFS=","
533 for g in ${egroups} ; do
534 dscl . merge /groups/${g} users ${euser}
535 done
536 export IFS=${oldifs}
537 else
538 einfo "Extra options are not supported on Darwin yet"
539 einfo "Please report the ebuild along with the info below"
540 einfo "eextra: $@"
541 die "Required function missing"
542 fi
543 ;;
544 *-freebsd*|*-dragonfly*)
545 if [[ -z $@ ]] ; then
546 pw useradd ${euser} ${opts} \
547 -c "added by portage for ${PN}" \
548 die "enewuser failed"
549 else
550 einfo " - Extra: $@"
551 pw useradd ${euser} ${opts} \
552 "$@" || die "enewuser failed"
553 fi
554 ;;
555
556 *-netbsd*)
557 if [[ -z $@ ]] ; then
558 useradd ${opts} ${euser} || die "enewuser failed"
559 else
560 einfo " - Extra: $@"
561 useradd ${opts} ${euser} "$@" || die "enewuser failed"
562 fi
563 ;;
564
565 *-openbsd*)
566 if [[ -z $@ ]] ; then
567 useradd -u ${euid} -s ${eshell} \
568 -d ${ehome} -c "Added by portage for ${PN}" \
569 -g ${egroups} ${euser} || die "enewuser failed"
570 else
571 einfo " - Extra: $@"
572 useradd -u ${euid} -s ${eshell} \
573 -d ${ehome} -c "Added by portage for ${PN}" \
574 -g ${egroups} ${euser} "$@" || die "enewuser failed"
575 fi
576 ;;
577
578 *)
579 if [[ -z $@ ]] ; then
580 useradd ${opts} ${euser} \
581 -c "added by portage for ${PN}" \
582 || die "enewuser failed"
583 else
584 einfo " - Extra: $@"
585 useradd ${opts} ${euser} "$@" \
586 || die "enewuser failed"
587 fi
588 ;;
589 esac
590
591 if [[ ! -e ${ROOT}/${ehome} ]] ; then
592 einfo " - Creating ${ehome} in ${ROOT}"
593 mkdir -p "${ROOT}/${ehome}"
594 chown ${euser} "${ROOT}/${ehome}"
595 chmod 755 "${ROOT}/${ehome}"
596 fi
597
598 export SANDBOX_ON=${oldsandbox}
599}
600
601# @FUNCTION: enewgroup
602# @USAGE: <group> [gid]
603# @DESCRIPTION:
604# This function does not require you to understand how to properly add a
605# group to the system. Just give it a group name to add and enewgroup will
606# do the rest. You may specify the gid for the group or allow the group to
607# allocate the next available one.
608enewgroup() {
609 case ${EBUILD_PHASE} in
610 unpack|compile|test|install)
611 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
612 eerror "Package fails at QA and at life. Please file a bug."
613 die "Bad package! enewgroup is only for use in pkg_* functions!"
614 esac
615
616 # get the group
617 local egroup="$1"; shift
618 if [ -z "${egroup}" ]
619 then
620 eerror "No group specified !"
621 die "Cannot call enewgroup without a group"
622 fi
623
624 # see if group already exists
625 if [[ -n $(egetent group "${egroup}") ]]; then
626 return 0
627 fi
628 einfo "Adding group '${egroup}' to your system ..."
629
630 # options to pass to useradd
631 local opts=
632
633 # handle gid
634 local egid="$1"; shift
635 if [ ! -z "${egid}" ]
636 then
637 if [ "${egid}" -gt 0 ]
638 then
639 if [ -z "`egetent group ${egid}`" ]
640 then
641 if [[ "${CHOST}" == *-darwin* ]]; then
642 opts="${opts} ${egid}"
643 else
644 opts="${opts} -g ${egid}"
645 fi
646 else
647 egid="next available; requested gid taken"
648 fi
649 else
650 eerror "Groupid given but is not greater than 0 !"
651 die "${egid} is not a valid GID"
652 fi
653 else
654 egid="next available"
655 fi
656 einfo " - Groupid: ${egid}"
657
658 # handle extra
659 local eextra="$@"
660 opts="${opts} ${eextra}"
661
662 # add the group
663 local oldsandbox="${SANDBOX_ON}"
664 export SANDBOX_ON="0"
665 case ${CHOST} in
666 *-darwin*)
667 if [ ! -z "${eextra}" ];
668 then
669 einfo "Extra options are not supported on Darwin/OS X yet"
670 einfo "Please report the ebuild along with the info below"
671 einfo "eextra: ${eextra}"
672 die "Required function missing"
673 fi
674
675 # If we need the next available
676 case ${egid} in
677 *[!0-9]*) # Non numeric
678 for ((egid = 101; egid <= 999; egid++)); do
679 [[ -z $(egetent group ${egid}) ]] && break
680 done
681 esac
682 dscl . create /groups/${egroup} gid ${egid}
683 dscl . create /groups/${egroup} passwd '*'
684 ;;
685
686 *-freebsd*|*-dragonfly*)
687 case ${egid} in
688 *[!0-9]*) # Non numeric
689 for ((egid = 101; egid <= 999; egid++)); do
690 [[ -z $(egetent group ${egid}) ]] && break
691 done
692 esac
693 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
694 ;;
695
696 *-netbsd*)
697 case ${egid} in
698 *[!0-9]*) # Non numeric
699 for ((egid = 101; egid <= 999; egid++)); do
700 [[ -z $(egetent group ${egid}) ]] && break
701 done
702 esac
703 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
704 ;;
705
706 *)
707 groupadd ${opts} ${egroup} || die "enewgroup failed"
708 ;;
709 esac
710 export SANDBOX_ON="${oldsandbox}"
711}
712
713# @FUNCTION: edos2unix 600# @FUNCTION: edos2unix
714# @USAGE: <file> [more files ...] 601# @USAGE: <file> [more files ...]
715# @DESCRIPTION: 602# @DESCRIPTION:
716# A handy replacement for dos2unix, recode, fixdos, etc... This allows you 603# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
717# to remove all of these text utilities from DEPEND variables because this 604# to remove all of these text utilities from DEPEND variables because this
718# is a script based solution. Just give it a list of files to convert and 605# is a script based solution. Just give it a list of files to convert and
719# they will all be changed from the DOS CRLF format to the UNIX LF format. 606# they will all be changed from the DOS CRLF format to the UNIX LF format.
720edos2unix() { 607edos2unix() {
721 echo "$@" | xargs sed -i 's/\r$//' 608 [[ $# -eq 0 ]] && return 0
609 sed -i 's/\r$//' -- "$@" || die
722} 610}
723 611
612# @FUNCTION: make_desktop_entry
613# @USAGE: make_desktop_entry(<command>, [name], [icon], [type], [fields])
614# @DESCRIPTION:
724# Make a desktop file ! 615# Make a .desktop file.
725# Great for making those icons in kde/gnome startmenu !
726# Amaze your friends ! Get the women ! Join today !
727# 616#
728# make_desktop_entry(<command>, [name], [icon], [type], [path]) 617# @CODE
729#
730# binary: what command does the app run with ? 618# binary: what command does the app run with ?
731# name: the name that will show up in the menu 619# name: the name that will show up in the menu
732# icon: give your little like a pretty little icon ... 620# icon: give your little like a pretty little icon ...
733# this can be relative (to /usr/share/pixmaps) or 621# this can be relative (to /usr/share/pixmaps) or
734# a full path to an icon 622# a full path to an icon
735# type: what kind of application is this ? for categories: 623# type: what kind of application is this?
624# for categories:
736# http://standards.freedesktop.org/menu-spec/latest/apa.html 625# http://standards.freedesktop.org/menu-spec/latest/apa.html
737# path: if your app needs to startup in a specific dir 626# if unset, function tries to guess from package's category
627# fields: extra fields to append to the desktop file; a printf string
628# @CODE
738make_desktop_entry() { 629make_desktop_entry() {
739 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 630 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
740 631
741 local exec=${1} 632 local exec=${1}
742 local name=${2:-${PN}} 633 local name=${2:-${PN}}
743 local icon=${3:-${PN}} 634 local icon=${3:-${PN}}
744 local type=${4} 635 local type=${4}
745 local path=${5} 636 local fields=${5}
746 637
747 if [[ -z ${type} ]] ; then 638 if [[ -z ${type} ]] ; then
748 local catmaj=${CATEGORY%%-*} 639 local catmaj=${CATEGORY%%-*}
749 local catmin=${CATEGORY##*-} 640 local catmin=${CATEGORY##*-}
750 case ${catmaj} in 641 case ${catmaj} in
751 app) 642 app)
752 case ${catmin} in 643 case ${catmin} in
753 accessibility) type=Accessibility;; 644 accessibility) type=Accessibility;;
754 admin) type=System;; 645 admin) type=System;;
755 antivirus) type=System;; 646 antivirus) type=System;;
756 arch) type=Archiving;; 647 arch) type=Archiving;;
757 backup) type=Archiving;; 648 backup) type=Archiving;;
758 cdr) type=DiscBurning;; 649 cdr) type=DiscBurning;;
759 dicts) type=Dictionary;; 650 dicts) type=Dictionary;;
760 doc) type=Documentation;; 651 doc) type=Documentation;;
761 editors) type=TextEditor;; 652 editors) type=TextEditor;;
762 emacs) type=TextEditor;; 653 emacs) type=TextEditor;;
763 emulation) type=Emulator;; 654 emulation) type=Emulator;;
764 laptop) type=HardwareSettings;; 655 laptop) type=HardwareSettings;;
765 office) type=Office;; 656 office) type=Office;;
766 pda) type=PDA;; 657 pda) type=PDA;;
767 vim) type=TextEditor;; 658 vim) type=TextEditor;;
768 xemacs) type=TextEditor;; 659 xemacs) type=TextEditor;;
769 *) type=;;
770 esac 660 esac
771 ;; 661 ;;
772 662
773 dev) 663 dev)
774 type="Development" 664 type="Development"
775 ;; 665 ;;
776 666
777 games) 667 games)
778 case ${catmin} in 668 case ${catmin} in
779 action|fps) type=ActionGame;; 669 action|fps) type=ActionGame;;
780 arcade) type=ArcadeGame;; 670 arcade) type=ArcadeGame;;
781 board) type=BoardGame;; 671 board) type=BoardGame;;
782 emulation) type=Emulator;; 672 emulation) type=Emulator;;
783 kids) type=KidsGame;; 673 kids) type=KidsGame;;
784 puzzle) type=LogicGame;; 674 puzzle) type=LogicGame;;
785 roguelike) type=RolePlaying;; 675 roguelike) type=RolePlaying;;
786 rpg) type=RolePlaying;; 676 rpg) type=RolePlaying;;
787 simulation) type=Simulation;; 677 simulation) type=Simulation;;
788 sports) type=SportsGame;; 678 sports) type=SportsGame;;
789 strategy) type=StrategyGame;; 679 strategy) type=StrategyGame;;
790 *) type=;;
791 esac 680 esac
792 type="Game;${type}" 681 type="Game;${type}"
793 ;; 682 ;;
794 683
795 gnome) 684 gnome)
804 type="Network;Email" 693 type="Network;Email"
805 ;; 694 ;;
806 695
807 media) 696 media)
808 case ${catmin} in 697 case ${catmin} in
698 gfx)
809 gfx) type=Graphics;; 699 type=Graphics
700 ;;
701 *)
702 case ${catmin} in
810 radio) type=Tuner;; 703 radio) type=Tuner;;
811 sound) type=Audio;; 704 sound) type=Audio;;
812 tv) type=TV;; 705 tv) type=TV;;
813 video) type=Video;; 706 video) type=Video;;
814 *) type=;; 707 esac
708 type="AudioVideo;${type}"
709 ;;
815 esac 710 esac
816 type="AudioVideo;${type}"
817 ;; 711 ;;
818 712
819 net) 713 net)
820 case ${catmin} in 714 case ${catmin} in
821 dialup) type=Dialup;; 715 dialup) type=Dialup;;
822 ftp) type=FileTransfer;; 716 ftp) type=FileTransfer;;
823 im) type=InstantMessaging;; 717 im) type=InstantMessaging;;
824 irc) type=IRCClient;; 718 irc) type=IRCClient;;
825 mail) type=Email;; 719 mail) type=Email;;
826 news) type=News;; 720 news) type=News;;
827 nntp) type=News;; 721 nntp) type=News;;
828 p2p) type=FileTransfer;; 722 p2p) type=FileTransfer;;
829 *) type=;; 723 voip) type=Telephony;;
830 esac 724 esac
831 type="Network;${type}" 725 type="Network;${type}"
832 ;; 726 ;;
833 727
834 sci) 728 sci)
835 case ${catmin} in 729 case ${catmin} in
836 astro*) type=Astronomy;; 730 astro*) type=Astronomy;;
837 bio*) type=Biology;; 731 bio*) type=Biology;;
838 calc*) type=Calculator;; 732 calc*) type=Calculator;;
839 chem*) type=Chemistry;; 733 chem*) type=Chemistry;;
840 elec*) type=Electronics;; 734 elec*) type=Electronics;;
841 geo*) type=Geology;; 735 geo*) type=Geology;;
842 math*) type=Math;; 736 math*) type=Math;;
843 physics) type=Physics;; 737 physics) type=Physics;;
844 visual*) type=DataVisualization;; 738 visual*) type=DataVisualization;;
845 *) type=;;
846 esac 739 esac
847 type="Science;${type}" 740 type="Education;Science;${type}"
848 ;; 741 ;;
849 742
850 sys) 743 sys)
851 type="System" 744 type="System"
852 ;; 745 ;;
853 746
854 www) 747 www)
855 case ${catmin} in 748 case ${catmin} in
856 client) type=WebBrowser;; 749 client) type=WebBrowser;;
857 *) type=;;
858 esac 750 esac
859 type="Network" 751 type="Network;${type}"
860 ;; 752 ;;
861 753
862 *) 754 *)
863 type= 755 type=
864 ;; 756 ;;
870 local desktop_name="${PN}-${SLOT}" 762 local desktop_name="${PN}-${SLOT}"
871 fi 763 fi
872 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop" 764 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
873 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop 765 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
874 766
767 # Don't append another ";" when a valid category value is provided.
768 type=${type%;}${type:+;}
769
770 eshopts_push -s extglob
771 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
772 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
773 ewarn "allowed in .desktop files if the value is not an absolute path."
774 icon=${icon%.@(xpm|png|svg)}
775 fi
776 eshopts_pop
777
875 cat <<-EOF > "${desktop}" 778 cat <<-EOF > "${desktop}"
876 [Desktop Entry] 779 [Desktop Entry]
877 Version=1.0
878 Name=${name} 780 Name=${name}
879 Type=Application 781 Type=Application
880 Comment=${DESCRIPTION} 782 Comment=${DESCRIPTION}
881 Exec=${exec} 783 Exec=${exec}
882 TryExec=${exec%% *} 784 TryExec=${exec%% *}
883 Icon=${icon} 785 Icon=${icon}
884 Categories=${type}; 786 Categories=${type}
885 EOF 787 EOF
886 788
887 [[ ${path} ]] && echo "Path=${path}" >> "${desktop}" 789 if [[ ${fields:-=} != *=* ]] ; then
790 # 5th arg used to be value to Path=
791 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
792 fields="Path=${fields}"
793 fi
794 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
888 795
889 ( 796 (
890 # wrap the env here so that the 'insinto' call 797 # wrap the env here so that the 'insinto' call
891 # doesn't corrupt the env of the caller 798 # doesn't corrupt the env of the caller
892 insinto /usr/share/applications 799 insinto /usr/share/applications
893 doins "${desktop}" 800 doins "${desktop}"
894 ) 801 ) || die "installing desktop file failed"
895} 802}
896 803
897# @FUNCTION: validate_desktop_entries 804# @FUNCTION: validate_desktop_entries
898# @USAGE: [directories] 805# @USAGE: [directories]
899# @MAINTAINER: 806# @MAINTAINER:
921 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo." 828 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
922 fi 829 fi
923} 830}
924 831
925# @FUNCTION: make_session_desktop 832# @FUNCTION: make_session_desktop
926# @USAGE: <title> <command> 833# @USAGE: <title> <command> [command args...]
927# @DESCRIPTION: 834# @DESCRIPTION:
928# Make a GDM/KDM Session file. The title is the file to execute to start the 835# Make a GDM/KDM Session file. The title is the file to execute to start the
929# Window Manager. The command is the name of the Window Manager. 836# Window Manager. The command is the name of the Window Manager.
837#
838# You can set the name of the file via the ${wm} variable.
930make_session_desktop() { 839make_session_desktop() {
931 [[ -z $1 ]] && eerror "make_session_desktop: You must specify the title" && return 1 840 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
932 [[ -z $2 ]] && eerror "make_session_desktop: You must specify the command" && return 1 841 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
933 842
934 local title=$1 843 local title=$1
935 local command=$2 844 local command=$2
936 local desktop=${T}/${wm}.desktop 845 local desktop=${T}/${wm:-${PN}}.desktop
846 shift 2
937 847
938 cat <<-EOF > "${desktop}" 848 cat <<-EOF > "${desktop}"
939 [Desktop Entry] 849 [Desktop Entry]
940 Name=${title} 850 Name=${title}
941 Comment=This session logs you into ${title} 851 Comment=This session logs you into ${title}
942 Exec=${command} 852 Exec=${command} $*
943 TryExec=${command} 853 TryExec=${command}
944 Type=Application 854 Type=XSession
945 EOF 855 EOF
946 856
947 ( 857 (
948 # wrap the env here so that the 'insinto' call 858 # wrap the env here so that the 'insinto' call
949 # doesn't corrupt the env of the caller 859 # doesn't corrupt the env of the caller
1175 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'" 1085 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1176 1086
1177 local shrtsrc=$(basename "${src}") 1087 local shrtsrc=$(basename "${src}")
1178 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1088 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1179 if [[ -z ${skip} ]] ; then 1089 if [[ -z ${skip} ]] ; then
1180 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}') 1090 local ver=$(grep -m1 -a '#.*Makeself' "${src}" | awk '{print $NF}')
1181 local skip=0 1091 local skip=0
1182 exe=tail 1092 exe=tail
1183 case ${ver} in 1093 case ${ver} in
1184 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 1094 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1185 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 1095 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1187 2.0|2.0.1) 1097 2.0|2.0.1)
1188 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-) 1098 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1189 ;; 1099 ;;
1190 2.1.1) 1100 2.1.1)
1191 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-) 1101 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1192 let skip="skip + 1" 1102 (( skip++ ))
1193 ;; 1103 ;;
1194 2.1.2) 1104 2.1.2)
1195 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1) 1105 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1196 let skip="skip + 1" 1106 (( skip++ ))
1197 ;; 1107 ;;
1198 2.1.3) 1108 2.1.3)
1199 skip=`grep -a ^offset= "${src}" | awk '{print $3}'` 1109 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1200 let skip="skip + 1" 1110 (( skip++ ))
1201 ;; 1111 ;;
1202 2.1.4|2.1.5) 1112 2.1.4|2.1.5)
1203 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1) 1113 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1204 skip=$(head -n ${skip} "${src}" | wc -c) 1114 skip=$(head -n ${skip} "${src}" | wc -c)
1205 exe="dd" 1115 exe="dd"
1214 esac 1124 esac
1215 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset" 1125 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1216 fi 1126 fi
1217 case ${exe} in 1127 case ${exe} in
1218 tail) exe="tail -n +${skip} '${src}'";; 1128 tail) exe="tail -n +${skip} '${src}'";;
1219 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";; 1129 dd) exe="dd ibs=${skip} skip=1 if='${src}'";;
1220 *) die "makeself cant handle exe '${exe}'" 1130 *) die "makeself cant handle exe '${exe}'"
1221 esac 1131 esac
1222 1132
1223 # lets grab the first few bytes of the file to figure out what kind of archive it is 1133 # lets grab the first few bytes of the file to figure out what kind of archive it is
1224 local tmpfile=$(emktemp) 1134 local filetype tmpfile=$(emktemp)
1225 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}" 1135 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1226 local filetype=$(file -b "${tmpfile}") 1136 filetype=$(file -b "${tmpfile}") || die
1227 case ${filetype} in 1137 case ${filetype} in
1228 *tar\ archive*) 1138 *tar\ archive*)
1229 eval ${exe} | tar --no-same-owner -xf - 1139 eval ${exe} | tar --no-same-owner -xf -
1230 ;; 1140 ;;
1231 bzip2*) 1141 bzip2*)
1241 eerror "Unknown filetype \"${filetype}\" ?" 1151 eerror "Unknown filetype \"${filetype}\" ?"
1242 false 1152 false
1243 ;; 1153 ;;
1244 esac 1154 esac
1245 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})" 1155 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1246}
1247
1248# @FUNCTION: check_license
1249# @USAGE: [license]
1250# @DESCRIPTION:
1251# Display a license for user to accept. If no license is
1252# specified, then ${LICENSE} is used.
1253check_license() {
1254 local lic=$1
1255 if [ -z "${lic}" ] ; then
1256 lic="${PORTDIR}/licenses/${LICENSE}"
1257 else
1258 if [ -e "${PORTDIR}/licenses/${lic}" ] ; then
1259 lic="${PORTDIR}/licenses/${lic}"
1260 elif [ -e "${PWD}/${lic}" ] ; then
1261 lic="${PWD}/${lic}"
1262 elif [ -e "${lic}" ] ; then
1263 lic="${lic}"
1264 fi
1265 fi
1266 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1267 local l="`basename ${lic}`"
1268
1269 # here is where we check for the licenses the user already
1270 # accepted ... if we don't find a match, we make the user accept
1271 local shopts=$-
1272 local alic
1273 set -o noglob #so that bash doesn't expand "*"
1274 for alic in ${ACCEPT_LICENSE} ; do
1275 if [[ ${alic} == ${l} ]]; then
1276 set +o noglob; set -${shopts} #reset old shell opts
1277 return 0
1278 fi
1279 done
1280 set +o noglob; set -$shopts #reset old shell opts
1281
1282 local licmsg=$(emktemp)
1283 cat <<-EOF > ${licmsg}
1284 **********************************************************
1285 The following license outlines the terms of use of this
1286 package. You MUST accept this license for installation to
1287 continue. When you are done viewing, hit 'q'. If you
1288 CTRL+C out of this, the install will not run!
1289 **********************************************************
1290
1291 EOF
1292 cat ${lic} >> ${licmsg}
1293 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1294 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1295 read alic
1296 case ${alic} in
1297 yes|Yes|y|Y)
1298 return 0
1299 ;;
1300 *)
1301 echo;echo;echo
1302 eerror "You MUST accept the license to continue! Exiting!"
1303 die "Failed to accept license"
1304 ;;
1305 esac
1306} 1156}
1307 1157
1308# @FUNCTION: cdrom_get_cds 1158# @FUNCTION: cdrom_get_cds
1309# @USAGE: <file on cd1> [file on cd2] [file on cd3] [...] 1159# @USAGE: <file on cd1> [file on cd2] [file on cd3] [...]
1310# @DESCRIPTION: 1160# @DESCRIPTION:
1358 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}} 1208 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1359 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1209 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1360 export CDROM_SET=-1 1210 export CDROM_SET=-1
1361 for f in ${CDROM_CHECK_1//:/ } ; do 1211 for f in ${CDROM_CHECK_1//:/ } ; do
1362 ((++CDROM_SET)) 1212 ((++CDROM_SET))
1363 [[ -e ${CD_ROOT}/${f} ]] && break 1213 [[ -e ${CDROM_ROOT}/${f} ]] && break
1364 done 1214 done
1365 export CDROM_MATCH=${f} 1215 export CDROM_MATCH=${f}
1366 return 1216 return
1367 fi 1217 fi
1368 1218
1532# of the lists. 1382# of the lists.
1533strip-linguas() { 1383strip-linguas() {
1534 local ls newls nols 1384 local ls newls nols
1535 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then 1385 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1536 local op=$1; shift 1386 local op=$1; shift
1537 ls=$(find "$1" -name '*.po' -exec basename {} .po \;); shift 1387 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1538 local d f 1388 local d f
1539 for d in "$@" ; do 1389 for d in "$@" ; do
1540 if [[ ${op} == "-u" ]] ; then 1390 if [[ ${op} == "-u" ]] ; then
1541 newls=${ls} 1391 newls=${ls}
1542 else 1392 else
1543 newls="" 1393 newls=""
1544 fi 1394 fi
1545 for f in $(find "$d" -name '*.po' -exec basename {} .po \;) ; do 1395 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1546 if [[ ${op} == "-i" ]] ; then 1396 if [[ ${op} == "-i" ]] ; then
1547 hasq ${f} ${ls} && newls="${newls} ${f}" 1397 has ${f} ${ls} && newls="${newls} ${f}"
1548 else 1398 else
1549 hasq ${f} ${ls} || newls="${newls} ${f}" 1399 has ${f} ${ls} || newls="${newls} ${f}"
1550 fi 1400 fi
1551 done 1401 done
1552 ls=${newls} 1402 ls=${newls}
1553 done 1403 done
1554 else 1404 else
1556 fi 1406 fi
1557 1407
1558 nols="" 1408 nols=""
1559 newls="" 1409 newls=""
1560 for f in ${LINGUAS} ; do 1410 for f in ${LINGUAS} ; do
1561 if hasq ${f} ${ls} ; then 1411 if has ${f} ${ls} ; then
1562 newls="${newls} ${f}" 1412 newls="${newls} ${f}"
1563 else 1413 else
1564 nols="${nols} ${f}" 1414 nols="${nols} ${f}"
1565 fi 1415 fi
1566 done 1416 done
1567 [[ -n ${nols} ]] \ 1417 [[ -n ${nols} ]] \
1568 && ewarn "Sorry, but ${PN} does not support the LINGUAs:" ${nols} 1418 && ewarn "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1569 export LINGUAS=${newls:1} 1419 export LINGUAS=${newls:1}
1570} 1420}
1571 1421
1572# @FUNCTION: preserve_old_lib 1422# @FUNCTION: preserve_old_lib
1573# @USAGE: <libs to preserve> [more libs] 1423# @USAGE: <libs to preserve> [more libs]
1583 eerror "preserve_old_lib() must be called from pkg_preinst() only" 1433 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1584 die "Invalid preserve_old_lib() usage" 1434 die "Invalid preserve_old_lib() usage"
1585 fi 1435 fi
1586 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]" 1436 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1587 1437
1438 # let portage worry about it
1439 has preserve-libs ${FEATURES} && return 0
1440
1588 local lib dir 1441 local lib dir
1589 for lib in "$@" ; do 1442 for lib in "$@" ; do
1590 [[ -e ${ROOT}/${lib} ]] || continue 1443 [[ -e ${ROOT}/${lib} ]] || continue
1591 dir=${lib%/*} 1444 dir=${lib%/*}
1592 dodir ${dir} || die "dodir ${dir} failed" 1445 dodir ${dir} || die "dodir ${dir} failed"
1602preserve_old_lib_notify() { 1455preserve_old_lib_notify() {
1603 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then 1456 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1604 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only" 1457 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1605 die "Invalid preserve_old_lib_notify() usage" 1458 die "Invalid preserve_old_lib_notify() usage"
1606 fi 1459 fi
1460
1461 # let portage worry about it
1462 has preserve-libs ${FEATURES} && return 0
1607 1463
1608 local lib notice=0 1464 local lib notice=0
1609 for lib in "$@" ; do 1465 for lib in "$@" ; do
1610 [[ -e ${ROOT}/${lib} ]] || continue 1466 [[ -e ${ROOT}/${lib} ]] || continue
1611 if [[ ${notice} -eq 0 ]] ; then 1467 if [[ ${notice} -eq 0 ]] ; then
1615 ewarn "the libraries are not being removed. You need to run revdep-rebuild" 1471 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1616 ewarn "in order to remove these old dependencies. If you do not have this" 1472 ewarn "in order to remove these old dependencies. If you do not have this"
1617 ewarn "helper program, simply emerge the 'gentoolkit' package." 1473 ewarn "helper program, simply emerge the 'gentoolkit' package."
1618 ewarn 1474 ewarn
1619 fi 1475 fi
1476 # temp hack for #348634 #357225
1477 [[ ${PN} == "mpfr" ]] && lib=${lib##*/}
1620 ewarn " # revdep-rebuild --library ${lib##*/}" 1478 ewarn " # revdep-rebuild --library '${lib}'"
1621 done 1479 done
1622 if [[ ${notice} -eq 1 ]] ; then 1480 if [[ ${notice} -eq 1 ]] ; then
1623 ewarn 1481 ewarn
1624 ewarn "Once you've finished running revdep-rebuild, it should be safe to" 1482 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1625 ewarn "delete the old libraries." 1483 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1484 for lib in "$@" ; do
1485 ewarn " # rm '${lib}'"
1486 done
1626 fi 1487 fi
1627} 1488}
1628 1489
1629# @FUNCTION: built_with_use 1490# @FUNCTION: built_with_use
1630# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags> 1491# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1631# @DESCRIPTION: 1492# @DESCRIPTION:
1493#
1494# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1495#
1632# A temporary hack until portage properly supports DEPENDing on USE 1496# A temporary hack until portage properly supports DEPENDing on USE
1633# flags being enabled in packages. This will check to see if the specified 1497# flags being enabled in packages. This will check to see if the specified
1634# DEPEND atom was built with the specified list of USE flags. The 1498# DEPEND atom was built with the specified list of USE flags. The
1635# --missing option controls the behavior if called on a package that does 1499# --missing option controls the behavior if called on a package that does
1636# not actually support the defined USE flags (aka listed in IUSE). 1500# not actually support the defined USE flags (aka listed in IUSE).
1637# The default is to abort (call die). The -a and -o flags control 1501# The default is to abort (call die). The -a and -o flags control
1638# the requirements of the USE flags. They correspond to "and" and "or" 1502# the requirements of the USE flags. They correspond to "and" and "or"
1639# logic. So the -a flag means all listed USE flags must be enabled 1503# logic. So the -a flag means all listed USE flags must be enabled
1640# while the -o flag means at least one of the listed fIUSE flags must be 1504# while the -o flag means at least one of the listed IUSE flags must be
1641# enabled. The --hidden option is really for internal use only as it 1505# enabled. The --hidden option is really for internal use only as it
1642# means the USE flag we're checking is hidden expanded, so it won't be found 1506# means the USE flag we're checking is hidden expanded, so it won't be found
1643# in IUSE like normal USE flags. 1507# in IUSE like normal USE flags.
1644# 1508#
1645# Remember that this function isn't terribly intelligent so order of optional 1509# Remember that this function isn't terribly intelligent so order of optional
1680 die) die "Unable to determine what USE flags $PKG was built with";; 1544 die) die "Unable to determine what USE flags $PKG was built with";;
1681 esac 1545 esac
1682 fi 1546 fi
1683 1547
1684 if [[ ${hidden} == "no" ]] ; then 1548 if [[ ${hidden} == "no" ]] ; then
1685 local IUSE_BUILT=$(<${IUSEFILE}) 1549 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1686 # Don't check USE_EXPAND #147237 1550 # Don't check USE_EXPAND #147237
1687 local expand 1551 local expand
1688 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do 1552 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1689 if [[ $1 == ${expand}_* ]] ; then 1553 if [[ $1 == ${expand}_* ]] ; then
1690 expand="" 1554 expand=""
1691 break 1555 break
1692 fi 1556 fi
1693 done 1557 done
1694 if [[ -n ${expand} ]] ; then 1558 if [[ -n ${expand} ]] ; then
1695 if ! has $1 ${IUSE_BUILT} ; then 1559 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1696 case ${missing_action} in 1560 case ${missing_action} in
1697 true) return 0;; 1561 true) return 0;;
1698 false) return 1;; 1562 false) return 1;;
1699 die) die "$PKG does not actually support the $1 USE flag!";; 1563 die) die "$PKG does not actually support the $1 USE flag!";;
1700 esac 1564 esac
1764 ) || die 1628 ) || die
1765 else 1629 else
1766 newbin "${tmpwrapper}" "${wrapper}" || die 1630 newbin "${tmpwrapper}" "${wrapper}" || die
1767 fi 1631 fi
1768} 1632}
1633
1634# @FUNCTION: path_exists
1635# @USAGE: [-a|-o] <paths>
1636# @DESCRIPTION:
1637# Check if the specified paths exist. Works for all types of paths
1638# (files/dirs/etc...). The -a and -o flags control the requirements
1639# of the paths. They correspond to "and" and "or" logic. So the -a
1640# flag means all the paths must exist while the -o flag means at least
1641# one of the paths must exist. The default behavior is "and". If no
1642# paths are specified, then the return value is "false".
1643path_exists() {
1644 local opt=$1
1645 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1646
1647 # no paths -> return false
1648 # same behavior as: [[ -e "" ]]
1649 [[ $# -eq 0 ]] && return 1
1650
1651 local p r=0
1652 for p in "$@" ; do
1653 [[ -e ${p} ]]
1654 : $(( r += $? ))
1655 done
1656
1657 case ${opt} in
1658 -a) return $(( r != 0 )) ;;
1659 -o) return $(( r == $# )) ;;
1660 esac
1661}
1662
1663# @FUNCTION: in_iuse
1664# @USAGE: <flag>
1665# @DESCRIPTION:
1666# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1667# as necessary.
1668#
1669# Note that this function should not be used in the global scope.
1670in_iuse() {
1671 debug-print-function ${FUNCNAME} "${@}"
1672 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1673
1674 local flag=${1}
1675 local liuse=( ${IUSE} )
1676
1677 has "${flag}" "${liuse[@]#[+-]}"
1678}
1679
1680# @FUNCTION: use_if_iuse
1681# @USAGE: <flag>
1682# @DESCRIPTION:
1683# Return true if the given flag is in USE and IUSE.
1684#
1685# Note that this function should not be used in the global scope.
1686use_if_iuse() {
1687 in_iuse $1 || return 1
1688 use $1
1689}
1690
1691# @FUNCTION: usex
1692# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1693# @DESCRIPTION:
1694# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1695# otherwise echo [false output][false suffix] (defaults to "no").
1696usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963
1697
1698check_license() { die "you no longer need this as portage supports ACCEPT_LICENSE itself"; }
1699
1700fi

Legend:
Removed from v.1.296  
changed lines
  Added in v.1.380

  ViewVC Help
Powered by ViewVC 1.1.20